<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/29/2003 *
 * ===============                              Last change: 11/11/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : install-inc.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Functions for installation procedure             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen fuer die Installationsroutine         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * @TODO Rewrite all constants in this include file                     *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

/************************************************************************
 *      YOU MAY ALSO WANT TO REMOVE THIS FILE AFTER INSTALLTION!        *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} // END - if

// Init variables
$mysql = array();
if ((REQUEST_ISSET_POST(('mysql'))) && (is_array(REQUEST_POST('mysql')))) $mysql = REQUEST_POST('mysql');

// Check if both passwords from SMTP are matching
if ((REQUEST_ISSET_GET('page') && (REQUEST_GET('page') == 5))) {
	// Okay, we have to check it
	if (REQUEST_ISSET_POST(('smtp_user')) && (!REQUEST_ISSET_POST(('smtp_host')))) {
		// Hostname not set
		OUTPUT_HTML(getMessage('INSTALL_SMTP_HOSTNAME_EMPTY')."<br />");
		REQUEST_SET_GET('page', 3);
	} // END - if

	if ((!REQUEST_ISSET_POST(('smtp_pass1'))) && (REQUEST_ISSET_POST(('smtp_pass2')))) {
		// Password is empty
		OUTPUT_HTML(getMessage('INSTALL_SMTP_PASS1_EMPTY')."<br />");
		REQUEST_SET_GET('page', 3);
	} // END - if

	if ((REQUEST_ISSET_POST(('smtp_pass1'))) && (!REQUEST_ISSET_POST(('smtp_pass2')))) {
		// Password repeat is empty
		OUTPUT_HTML(getMessage('INSTALL_SMTP_PASS2_EMPTY')."<br />");
		REQUEST_SET_GET('page', 3);
	} // END - if

	if (REQUEST_POST('smtp_pass1') != REQUEST_POST('smtp_pass1')) {
		// Passwords are not matching
		OUTPUT_HTML(getMessage('INSTALL_SMTP_PASS_MISMATCH')."<br />");
		REQUEST_SET_GET('page', 3);
	} // END - if
} // END - if

// Is MXChange installed or no admin registered so far?
if ((!isInstalled()) || (!isAdminRegistered())) {
	// Set URL for FORM actions
	define('__BURL_ACTION', constant('URL'));

	// Output page for entered value
	switch (REQUEST_GET('page')) {
		case 'welcome': // Welcome to the installation!
			LOAD_TEMPLATE('install_welcome');
			break;

		case '1': // Server path, base URL
			// Load template
			LOAD_TEMPLATE('install_page1');
			break;

		case '2': // MySQL data (alone!)
			if (empty($mysql['dbase']))  $mysql['dbase']  = 'your_database';
			if (empty($mysql['login']))  $mysql['login']  = 'your_login';
			if (empty($mysql['host']))   $mysql['host']   = 'localhost';
			if (empty($mysql['prefix'])) $mysql['prefix'] = 'mxchange';
			if (empty($mysql['type']))   $mysql['type']   = 'MyISAM';
			if (getTotalFatalErrors() > 0) {
				OUTPUT_HTML("<span class=\"install_fatal\">");
				foreach (getFatalArray() as $key => $err) {
					OUTPUT_HTML("  <strong>&middot;</strong>&nbsp;{--FATAL_NO--}".($key + 1).":&nbsp;".$err."<br />");
				}
				OUTPUT_HTML("</span><br />");
			}
			define('__MYSQL_HOST'  , $mysql['host']);
			define('__MYSQL_DBASE' , $mysql['dbase']);
			define('__MYSQL_PREFIX', $mysql['prefix']);
			define('__TABLE_TYPE'  , $mysql['type']);
			define('__MYSQL_LOGIN' , $mysql['login']);
			define('__SPATH_VALUE' , REQUEST_POST('spath'));
			define('__BURL_VALUE'  , REQUEST_POST('burl'));
			define('__TITLE_VALUE' , REQUEST_POST('title'));
			define('__SLOGAN_VALUE', REQUEST_POST('slogan'));
			define('__EMAIL_VALUE' , REQUEST_POST('email'));

			// Load template
			LOAD_TEMPLATE('install_page2');
			break;

		case '3':
			// Set more values
			define('__SPATH_VALUE' , REQUEST_POST('spath'));
			define('__BURL_VALUE'  , REQUEST_POST('burl'));
			define('__TITLE_VALUE' , REQUEST_POST('title'));
			define('__SLOGAN_VALUE', REQUEST_POST('slogan'));
			define('__EMAIL_VALUE' , REQUEST_POST('email'));

			// Use default SMTP data
			$smtpHost  = getConfig('SMTP_HOSTNAME');
			$smtpUser  = getConfig('SMTP_USER');
			$smtpPass1 = getConfig('SMTP_PASSWORD');
			$smtpPass2 = getConfig('SMTP_PASSWORD');

			// Overwrite it with the data from sent (failed) form
			if (REQUEST_ISSET_POST(('smtp_host'))) $smtpHost = REQUEST_POST('smtp_host');
			if (REQUEST_ISSET_POST(('smtp_user'))) $smtpUser = REQUEST_POST('smtp_user');
			if (REQUEST_ISSET_POST(('smtp_pass'))) {
				$smtpPass1 = REQUEST_POST('smtp_pass');
				$smtpPass2 = REQUEST_POST('smtp_pass');
			} // END - if

			// MySQL settings
			define('__MYSQL_HOST'  , $mysql['host']);
			define('__MYSQL_DBASE' , $mysql['dbase']);
			define('__MYSQL_PREFIX', $mysql['prefix']);
			define('__TABLE_TYPE'  , $mysql['type']);
			define('__MYSQL_LOGIN' , $mysql['login']);
			define('__MYSQL_PASS1' , $mysql['pass1']);
			define('__MYSQL_PASS2' , $mysql['pass2']);

			// Set constants for SMTP data
			define('__SMTP_HOST' , $smtpHost);
			define('__SMTP_USER' , $smtpUser);
			define('__SMTP_PASS1', $smtpPass1);
			define('__SMTP_PASS2', $smtpPass2);

			// Load template
			LOAD_TEMPLATE('install_page3');
			break;

		case '5': // Misc settings
			// General settings
			define('__SPATH_VALUE' , REQUEST_POST('spath'));
			define('__BURL_VALUE'  , REQUEST_POST('burl'));
			define('__TITLE_VALUE' , REQUEST_POST('title'));
			define('__SLOGAN_VALUE', REQUEST_POST('slogan'));
			define('__EMAIL_VALUE' , REQUEST_POST('email'));

			// MySQL settings
			define('__MYSQL_HOST'  , $mysql['host']);
			define('__MYSQL_DBASE' , $mysql['dbase']);
			define('__MYSQL_PREFIX', $mysql['prefix']);
			define('__TABLE_TYPE'  , $mysql['type']);
			define('__MYSQL_LOGIN' , $mysql['login']);

			// SMTP settings
			define('__SMTP_HOST', REQUEST_POST('smtp_host'));
			define('__SMTP_USER', REQUEST_POST('smtp_user'));
			define('__SMTP_PASS', REQUEST_POST('smtp_pass1'));
			OUTPUT_HTML("<form action=\"{!__BURL_ACTION!}/install.php?page=finalize\" method=\"POST\" target=\"_self\">
<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"install_main\">
<tr>
  <td colspan=\"2\" align=\"center\">
    <div class=\"install\">{--HEADER_TEXT_PAGE5--}</strong>
  </td>
</tr>
<tr><td colspan=\"2\" height=\"21\" class=\"seperator\">&nbsp;</td></tr>
<tr>
  <td colspan=\"2\"><span class=\"install_text\">
    {--TEXT_PAGE_5--}
  </span></td>
</tr>
<tr><td colspan=\"2\" height=\"21\" class=\"seperator\">&nbsp;</td></tr>
<tr>
  <td class=\"install\" align=\"right\">{--LANG_OUTPUT_MODE--}:&nbsp;&nbsp;</td>
  <td>
    <select name=\"omode\" size=\"1\" class=\"install_select\">
      <option value=\"render\">{--MODE_RENDER--}</option>
      <option value=\"direct\">{--MODE_DIRECT--}</option>
    </select>
  </td>
</tr>
<tr><td colspan=\"2\" height=\"10\" class=\"seperator\">&nbsp;</td></tr>
<tr>
  <td class=\"install\" align=\"right\">{--WARN_NO_PASSWORD--}:&nbsp;&nbsp;</td>
  <td>
    <select name=\"warn_no_pass\" size=\"1\" class=\"install_select\">
      <option value=\"Y\">{--YES--}</option>
      <option value=\"N\">{--NO--}</option>
    </select>
  </td>
</tr>
<tr><td colspan=\"2\" height=\"10\" class=\"seperator\">&nbsp;</td></tr>
<tr>
  <td class=\"install\" align=\"right\">{--LANG_WRITE_FOOTER--}:&nbsp;&nbsp;</td>
  <td>
    <select name=\"wfooter\" size=\"1\" class=\"install_select\">
      <option value=\"Y\">{--YES--}</option>
      <option value=\"N\">{--NO--}</option>
    </select>
  </td>
</tr>
<tr><td colspan=\"2\" height=\"10\" class=\"seperator\">&nbsp;</td></tr>
<tr>
  <td class=\"install\" align=\"right\">{--INSTALL_ENABLE_BACKLINK--}:&nbsp;&nbsp;</td>
  <td>
    <select name=\"blink\" size=\"1\" class=\"install_select\">
      <option value=\"Y\">{--YES--}</option>
      <option value=\"N\">{--NO--}</option>
    </select>
  </td>
</tr>
<tr><td colspan=\"2\" height=\"21\" class=\"seperator\">&nbsp;</td></tr>
<tr>
  <td colspan=\"2\" align=\"center\">");
			foreach ($mysql as $key => $value) {
				OUTPUT_HTML("    <input type=\"hidden\" name=\"mysql[".$key."]\" value=\"".$value."\" />");
			}
			OUTPUT_HTML("    <input type=\"hidden\" name=\"spath\" value=\"{!__SPATH_VALUE!}\" />
    <input type=\"hidden\" name=\"burl\" value=\"{!__BURL_VALUE!}\" />
    <input type=\"hidden\" name=\"title\" value=\"{!__TITLE_VALUE!}\" />
    <input type=\"hidden\" name=\"slogan\" value=\"{!__SLOGAN_VALUE!}\" />
    <input type=\"hidden\" name=\"email\" value=\"{!__EMAIL_VALUE!}\" />
    <input type=\"hidden\" name=\"smtp_host\" value=\"{!__SMTP_HOST!}\" />
    <input type=\"hidden\" name=\"smtp_user\" value=\"{!__SMTP_USER!}\" />
    <input type=\"hidden\" name=\"smtp_pass\" value=\"{!__SMTP_PASS!}\" />
    <input type=\"submit\" class=\"admin_submit submit\" name=\"finalize\" value=\"{--NEXT_PAGE--}\" class=\"install_submit\" />
  </td>
</tr>
<tr><td colspan=\"2\" height=\"21\" class=\"seperator\">&nbsp;</td></tr>
</table>
</form>");
			break;

		case 'finalize': // Write captured data to files
			if ((REQUEST_ISSET_POST('finalize')) && (!isInstalled())) {
				// You have submitted data then we have to reset the SQLs
				INIT_SQLS();

				// Connect to MySQL server
				SQL_CONNECT($mysql['host'], $mysql['login'], $mysql['pass1'], __FILE__, __LINE__);
				if (SQL_IS_LINK_UP()) {
					// Seems to work, also right database?
					if (SQL_SELECT_DB($mysql['dbase'], __FILE__, __LINE__) === true) {
						// Automatically run install.sql
						if ((!isFileReadable(REQUEST_POST('spath') . 'install/tables.sql')) || (!isFileReadable(REQUEST_POST('spath') . 'install/menu-'.getLanguage().'.sql'))) {
							// Installation area not found!
							addFatalMessage(__FILE__, __LINE__, getMessage('INSTALL_MISSING_DUMPS'));
						} // END - if

						if (getTotalFatalErrors() == 0) {
							// Both exists so import them
							foreach (array('tables', 'menu-'.getLanguage()) as $dump) {
								// Should be save here because file_exists() is there but we check it again. :)
								$FQFN = REQUEST_POST('spath') . 'install/' . $dump . '.sql';

								// Is the file readable?
								if (isFileReadable($FQFN)) {
									// Read the file
									$fileContent = readFromFile($FQFN, true);

									// Replace the {!prefix/type!} with actual one
									foreach (array('prefix', 'type') as $replace) {
										while (strpos($fileContent, '{!' . $replace . '!}') !== false) {
											$fileContent = str_replace('{!' . $replace . '!}', $mysql[$replace], $fileContent);
										} // END - while
									} // END - foreach

									// Split it up against ";\n" and merge it into existing SQLs
									MERGE_SQLS(explode(";\n", $fileContent));
								} else {
									// Not readable!
									debug_report_bug(sprintf("SQL dump %s is not readable!", $dump));
								}
							} // END - foreach

							// Are some SQLs found?
							if (COUNT_SQLS() == 0) {
								// Abort here
								addFatalMessage(__FILE__, __LINE__, getMessage('INSTALL_SQL_IMPORT_FAILED'));
								return;
							} // END - if

							// Now run all queries through and try to keep out empty or comment queries
							runFilterChain('run_sqls');

							// Copy the config template and verify it
							copyFileVerified(REQUEST_POST('spath') . 'inc/config-local.php.dist', REQUEST_POST('spath') . 'inc/cache/config-local.php', 0644);

							// Ok, all done. So we can write the config data to the php files
							if (REQUEST_POST('spath') != constant('PATH')) changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "SERVER-PATH", "define('PATH', \"", "\");", REQUEST_POST('spath'), 0);
							if (REQUEST_POST('burl')  != constant('URL'))  changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "HOST-URL", "define('URL', \"", "\");", REQUEST_POST('burl'), 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "MAIN-TITLE", "define('MAIN_TITLE', \"", "\");", REQUEST_POST('title'), 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "SLOGAN", "define('SLOGAN', \"", "\");", REQUEST_POST('slogan'), 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "WEBMASTER", "define('WEBMASTER', \"", "\");", REQUEST_POST('email'), 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "NULLPASS-WARNING", "setConfigEntry('WARN_NO_PASS', \"", "\");", REQUEST_POST('warn_no_pass'), 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "WRITE-FOOTER", "setConfigEntry('WRITE_FOOTER', \"", "\");", REQUEST_POST('wfooter'), 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "BACKLINK", "setConfigEntry('ENABLE_BACKLINK', \"", "\");", REQUEST_POST('blink'), 0);
							// DEACTIVATED: changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "OUTPUT-MODE", "define('OUTPUT_MODE', \"", "\");", REQUEST_POST('omode'), 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "MYSQL-HOST", "	'host'     => \"", "\",", $mysql['host'], 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "MYSQL-DBASE", "	'dbase'    => \"", "\",", $mysql['dbase'], 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "MYSQL-LOGIN", "	'login'    => \"", "\",", $mysql['login'], 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "MYSQL-PASSWORD", "	'password' => \"", "\",", $mysql['pass1'], 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "MYSQL-PREFIX", "setConfigEntry('_MYSQL_PREFIX', \"", "\");", $mysql['prefix'], 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "TABLE-TYPE", "setConfigEntry('_TABLE_TYPE', \"", "\");", $mysql['type'], 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "SMTP-HOSTNAME", "setConfigEntry('SMTP_HOSTNAME', \"", "\");", REQUEST_POST('smtp_host'), 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "SMTP-USER", "setConfigEntry('SMTP_USER', \"", "\");", REQUEST_POST('smtp_user'), 0);
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "SMTP-PASSWORD", "setConfigEntry('SMTP_PASSWORD', \"", "\");", REQUEST_POST('smtp_pass1'), 0);

							// Generate a long site key
							$siteKey = generatePassword(50);

							// And write it
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "SITE-KEY", "setConfigEntry('SITE_KEY', \"", "\");", $siteKey, 0);

							// Script is now installed
							changeDataInFile(REQUEST_POST('spath') . 'inc/cache/config-local.php', "INSTALLED", "setConfigEntry('MXCHANGE_INSTALLED', \"", "\");", 'Y', 0);
						} // END - if
					} // END - if
				} // END - if

				if (getTotalFatalErrors() > 0) {
					$OUT = '';
					foreach (getFatalArray() as $value) {
						$OUT .= "    <li>" . $value . "</li>\n";
					} // END foreach
					define('__FATAL_ERROR_LI', $OUT);
					$OUT = '';
					foreach ($mysql as $key => $value) {
						$OUT .= "    <input type=\"hidden\" name=\"mysql[" . $key . "]\" value=\"" . $value . "\" />\n";
					} // END foreach
					define('__MYSQL_DATA'	, $OUT);
					define('__SPATH_VALUE'	, REQUEST_POST('spath'));
					define('__BURL_VALUE'	, REQUEST_POST('burl'));
					define('__TITLE_VALUE'	, REQUEST_POST('title'));
					define('__SMTP_HOST'	, REQUEST_POST('smtp_host'));
					define('__SMTP_USER'	, REQUEST_POST('smtp_user'));
					define('__SMTP_PASS'	, REQUEST_POST('smtp_pass1'));

					// Load template
					LOAD_TEMPLATE('install_fatal_errors');
				} else {
					// Installation is done!
					redirectToUrl('install.php?page=finished');
				}
			} else {
				// Something goes wrong during installation! :-(
				addFatalMessage(__FILE__, __LINE__, getMessage('INSTALL_FINALIZER_FAILED'));
				loadInclude('inc/fatal_errors.php');
			}
			break;

		case 'finished':
			if (isInstalled()) {
				// Load template that we are finished
				LOAD_TEMPLATE('install_finished');
			} else {
				// Not finished
				redirectToUrl('install.php');
			}
			break;

		default:
			DEBUG_LOG(__FILE__, __LINE__, sprintf("Wrong page %s detected", REQUEST_GET('page')));
			OUTPUT_HTML("    <div class=\"install_error\">{--WRONG_PAGE--}</div>");
			break;
	}
} else {
	// Already installed!
	addFatalMessage(__FILE__, __LINE__, getMessage('ALREADY_INSTALLED'));
}

//
?>
