<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/09/2008 *
 * ================                             Last change: 09/09/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-primera.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Wernis requests                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auszahlungsanfragen                              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif (!IS_MEMBER()) {
	// User is not logged in
	redirectToUrl('modules.php?module=index');
} elseif ((!EXT_IS_ACTIVE('primera')) && (!IS_ADMIN())) {
	// Extension 'primera' is not activated
	addFatalMessage(__FILE__, __LINE__, generateExtensionInactiveMessage('primera'));
	return;
}

// Add description as navigation point
ADD_DESCR('member', __FILE__);

// Check if the admin has entered the data
if ((getConfig('primera_api_name') == '') || (getConfig('primera_api_md5') == '')) {
	// Something important is missing...
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_API_DATA_MISSING'));
	return;
}

// Init the content array and points
$content = array(); $points = false;

// Is the mode set (payout only)
if (!REQUEST_ISSET_GET(('mode'))) {
	// Get referal id
	$content['refid'] = getConfig(('primera_refid'));

	// Get Primus id
	$result = SQL_QUERY_ESC("SELECT primera_userid FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
	array(getUserId()), __FILE__, __LINE__);

	// Are there some entries?
	if (SQL_NUMROWS($result) == 1) {
		// Fetch ID
		list($content['primera_nickname']) = SQL_FETCHROW($result);
	} // END - if

	// Free result
	SQL_FREERESULT($result);

	// Is there an ID?
	if ((!empty($content['primera_nickname'])) && (!REQUEST_ISSET_GET(('mode')))) {
		// Then use an other "mode"
		REQUEST_SET_GET('mode', "list");

		// And load all rows!
		$result = SQL_QUERY_ESC("SELECT `id`,`primera_account`,`primera_amount`,`primera_timestamp`,`primera_type` FROM `{!_MYSQL_PREFIX!}_user_primera` WHERE `userid` = %s ORDER BY `primera_timestamp` DESC",
		array(getUserId()), __FILE__, __LINE__);

		// Load all rows
		$content['rows'] = ''; $SW = 2;
		while ($data = SQL_FETCHARRAY($result)) {
			// Prepare data for output
			$rowContent = array(
				'stamp'		=> generateDateTime($data['primera_timestamp'], '2'),
				'points'		=> translateComma($data['primera_amount']),
				'acc'		=> SQL_ESCAPE($data['primera_account']),
				'status'		=> PRIMERA_TRANSFER_STATUS($data['primera_type']),
				'raw_type'	=> strtolower($data['primera_type']),
				'sw'			=> $SW,
			);

			// Load row template
			$content['rows'] .= LOAD_TEMPLATE("member_primera_mode_list_row", true, $rowContent);
			$SW = 3 - $SW;
		}

		// Free result
		SQL_FREERESULT($result);
	} else {
		// Mode pay
		REQUEST_SET_GET('mode', "pay");
	}
} // END - if
if (REQUEST_GET('mode') == "pay") {
	// Get total points and check if the user can request a payout
	$points = GET_TOTAL_DATA(getUserId(), "user_points", "points") - GET_TOTAL_DATA(getUserId(), "user_data", "used_points");

	// No dots here...
	$points = explode('.', $points);
	$points = bigintval($points[0]);

	// Remove the registration fee
	$points = $points - getConfig('points_register');

	// Is this enougth for a payout?
	if ($points < getConfig('primera_min_payout')) {
		// No, then abort here
		LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_MIN_PAYOUT_PAYOUT'), translateComma(getConfig('primera_min_payout'))));
		return;
	}

	// Add points to content array
	$content['points'] 		= $points;
	$content['min_points']	= translateComma(getConfig('primera_min_payout'));

	// Get Primera id
	$content['primera_nickname'] = '';
	$result = SQL_QUERY_ESC("SELECT primera_userid FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
	array(getUserId()), __FILE__, __LINE__);

	// Are there some entries?
	if (SQL_NUMROWS($result) == 1) {
		// Fetch ID
		list($content['primera_nickname']) = SQL_FETCHROW($result);
	}

	// Free result
	SQL_FREERESULT($result);
} else {
	// Invalid mode!
	LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_MODE_INVALID'), REQUEST_GET(('mode'))));
	return;
}

// Is the formular sent?
if ((isFormSent()) && (REQUEST_ISSET_GET(('mode')))) {
	// Check input data depending on the mode and execute the requested mode
	switch (REQUEST_GET('mode')) {
		case "pay": // Payout this exchange -> Primus
			// Is the user ID and password set?
			if (!REQUEST_ISSET_POST(('primera_nickname'))) {
				// Nothing entered in Primus nickname
				LOAD_TEMPLATE('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_EMPTY_USERNAME'));
			} elseif (!REQUEST_ISSET_POST(('primera_password'))) {
				// Nothing entered in Primera password
				LOAD_TEMPLATE('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_EMPTY_PASSWORD'));
			} elseif (!REQUEST_ISSET_POST(('amount'))) {
				// Nothing entered in amount
				LOAD_TEMPLATE('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_EMPTY_AMOUNT'));
			} elseif (REQUEST_POST('amount') != bigintval(REQUEST_POST('amount'))) {
				// Only numbers in amount!
				LOAD_TEMPLATE('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_INVALID_AMOUNT'));
			} elseif (REQUEST_POST('amount') < getConfig('primera_min_payout')) {
				// Not enougth entered!
				LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_AMOUNT_SMALLER_MIN'), getConfig(('primera_min_payout'))));
			} elseif (REQUEST_POST('amount') > $points) {
				// Not enougth points left!
				LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_PAYOUT_POINTS_DEPLETED'), bigintval(REQUEST_POST('amount')), bigintval($points)));
			} else {
				// All is fine here so do the payout
				$success = PRIMERA_EXECUTE_PAYOUT(REQUEST_POST('primera_nickname'), md5(REQUEST_POST('primera_password')), REQUEST_POST('amount'));
				if ($success) {
					// Default is locked!
					$locked = true;

					// Shall I "pay" the referal points imidiately?
					if (getConfig('ref_payout') == '0') {
						// Yes, "pay" it now
						$locked = false;
					} // END - if

					// Remove points from account
					SUB_POINTS("primera_payout", getUserId(), REQUEST_POST('amount'));

					// Update primera nickname
					SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_user_data` SET `primera_userid`=%s WHERE userid=%s LIMIT 1",
					array(REQUEST_POST('primera_nickname'), getUserId()), __FILE__, __LINE__);

					// All done!
					LOAD_TEMPLATE('admin_settings_saved', false, getMessage('PRIMERA_MEMBER_PAYOUT_DONE'));
					return;
				} elseif ((GET_PRIMERA_ERROR_CODE() == "user_failed") || (GET_PRIMERA_ERROR_CODE() == "own_failed") || (GET_PRIMERA_ERROR_CODE() == "amount_failed") || (GET_PRIMERA_ERROR_CODE() == "api_amount_failed")) {
					// Wrong login data
					LOAD_TEMPLATE('admin_settings_saved', false, GET_PRIMERA_ERROR_MESSAGE());
				} else {
					// Something went wrong
					LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_PAYOUT_FAILED'), GET_PRIMERA_ERROR_MESSAGE()));
				}
			}
			break;

		default: // Invalid mode!
			DEBUG_LOG(__FILE__, __LINE__, sprintf("Invalid mode %s detected.", REQUEST_GET('mode')));
			LOAD_TEMPLATE('admin_settings_saved', false, sprintf(getMessage('PRIMERA_MEMBER_MODE_INVALID'), REQUEST_GET(('mode'))));
			return;
	}
} // END - if

// Prepare mode for template name
$mode = sprintf("member_primera_mode_%s", REQUEST_GET(('mode')));

// Load the template
LOAD_TEMPLATE($mode, false, $content);

//
?>
